unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MultiMonAPI, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    btShowMonitors: TButton;
    btClose: TButton;
    btRefresh: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btShowMonitorsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btShowMonitorsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btRefreshClick(Sender: TObject);
  private
    Monitors:TMonitors;
  public
    Procedure InitList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Procedure TForm1.InitList;
Var
  I : Integer;
begin
  Monitors:=TMonitors.Create(nil);
  ListBox.Clear;
  if Monitors.Count>0 then
  For I:=0 to Monitors.Count-1 do
  Begin
    ListBox.Items.Add(Monitors[I].Caption);
  End;
End;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Monitors:=TMonitors.Create(nil);
  InitList;
end;

procedure TForm1.ListBoxClick(Sender: TObject);
Const
  StrBool : Array[Boolean] of String = ('No','Yes');
begin
  if ListBox.ItemIndex<0 then Exit;
  With Monitors[ListBox.ItemIndex] do
  Begin
    Label10.Caption:=DeviceName;
    Label11.Caption:=Format('%d,%d-%d,%d',[DisplayRect.Left,DisplayRect.Top,DisplayRect.Right,DisplayRect.Bottom]);
    Label12.Caption:=Format('%d,%d-%d,%d',[WorkRect.Left,WorkRect.Top,WorkRect.Right,WorkRect.Bottom]);
    Label13.Caption:=Format('%dx%d',[Width,Height]);
    Label14.Caption:=StrBool[dsAttachedToDesktop in State];
    Label15.Caption:=StrBool[dsMultiDriver in State];
    Label16.Caption:=StrBool[dsPrimaryDevice in State];
    Label17.Caption:=StrBool[dsMirroringDriver in State];
    Label18.Caption:=StrBool[dsVGACompatible in State];
    Canvas.Save;
    Canvas.Brush.Style:=bsClear;
    Canvas.Pen.Color:=clRed;
    Canvas.Pen.Width:=5;
    Canvas.Rectangle(0,0,Width,Height);
    Sleep(100);
    Canvas.Restore;
    Canvas.FreeImage;
  End;
End;

procedure TForm1.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.btShowMonitorsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  I : Integer;
  S : String;
  ScrX,ScrY : Integer;
begin
  Screen.Cursor:=crNone;
  if Monitors.Count>0 then
  For I:=0 to Monitors.Count-1 do
  With Monitors[I].Canvas do
  Begin
//    Save;
    Font.Name:='Times new roman';
    Brush.Color:=clLtGray;
    FillRect(Rect(0,0,Monitors[I].Width,Monitors[I].Height));
    Brush.Style:=bsClear;
    Pen.Color:=clAqua;
    Pen.Width:=1;
    Rectangle(Monitors[I].WorkRect.Left,Monitors[I].WorkRect.Top,Monitors[I].WorkRect.Right,Monitors[I].WorkRect.Bottom);
    Font.Height:=200;
    S:='Screen '+IntToStr(I+1);
    Font.Color:=clWhite;
    ScrX:=Monitors[I].Width div 2;
    ScrY:=Monitors[I].Height div 2 - 150;
    TextOut(ScrX-TextWidth(S) div 2,ScrY,S);
    Font.Color:=clBlack;
    TextOut(ScrX-TextWidth(S) div 2+2,ScrY+2,S);
    Font.Height:=50;
    S:=Monitors[I].Caption;
    TextOut(ScrX-TextWidth(S) div 2,ScrY+210,S);
    Font.Height:=20;
    S:=Format('%d,%d-%d,%d    (%dx%d)',[Monitors[I].DisplayRect.Left,Monitors[I].DisplayRect.Top,Monitors[I].DisplayRect.Right,Monitors[I].DisplayRect.Bottom,Monitors[I].Width,Monitors[I].Height]);
    TextOut(ScrX-TextWidth(S) div 2,ScrY+265,S);
  End;
end;

procedure TForm1.btShowMonitorsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  I : Integer;
begin
  if Monitors.Count>0 then
  For I:=0 to Monitors.Count-1 do
  With Monitors[I].Canvas do
  Begin
    RepaintDesktop;
  End;
  btShowMonitors.Repaint;
  Screen.Cursor:=crDefault;
end;

procedure TForm1.btRefreshClick(Sender: TObject);
begin
  Monitors.Refresh;
  InitList;
end;

end.
